﻿using System;
using System.Text;
using System.IO;
using System.Net;
using System.Net.Sockets;

namespace SocketConsole
{
    public class GetSocket
    {
        private static Socket ConnectSocket(string server, int port)
        {
            Socket socket = null;
            IPHostEntry hostEntry = null;
            IPAddress ip;

            if (IPAddress.TryParse(server, out ip))
            {
                hostEntry = Dns.GetHostEntry(ip);
            }
            else
            {
                hostEntry = Dns.GetHostEntry(server);
            }


            foreach (IPAddress address in hostEntry.AddressList)
            {
                IPEndPoint ipe = new IPEndPoint(address, port);
                Socket tempSocket =
                    new Socket(ipe.AddressFamily, SocketType.Stream, ProtocolType.Tcp);

                tempSocket.Connect(ipe);

                if (tempSocket.Connected)
                {
                    socket = tempSocket;
                    break;
                }
                else
                {
                    continue;
                }
            }
            return socket;
        }

        private static string SocketSendReceive(string server, int port)
        {
            // Sample request data
            string request = "This is a test";
            Byte[] bytesSent = Encoding.ASCII.GetBytes(request);
            Byte[] bytesReceived = new Byte[256];

            // Create a socket connection with the specified server and port.
            Socket s = ConnectSocket(server, port);

            if (s == null)
                return ("Connection failed");

            // Send request to the server.
            s.Send(bytesSent, bytesSent.Length, 0);

            // Receive the server home page content.
            int bytes = 0;
            string page = "Resposne from " + server + ":\r\n";

            do
            {
                bytes = s.Receive(bytesReceived, bytesReceived.Length, 0);
                page = page + Encoding.ASCII.GetString(bytesReceived, 0, bytes);
            }
            while (bytes > 0);

            return page;
        }

        public static void Main(string[] args)
        {
            // IP or host name and port
            string host = "192.168.1.122";
            int port = 5000;

            string result = SocketSendReceive(host, port);
            Console.WriteLine(result);
        }
    }

}
